Imports System
Imports System.Text
Imports System.Net.Sockets
Imports System.IO
Imports System.Globalization

Public Class Program

    Shared Function IC() As IFormatProvider
        Return CultureInfo.InvariantCulture
    End Function

    Shared Function Parse(ByVal X As String, ByVal Y As String, ByVal D As String, ByVal V As String) As Stanje
        Return New Stanje(Double.Parse(X, IC), Double.Parse(Y, IC), Double.Parse(D, IC), Double.Parse(V, IC))
    End Function

    Shared Sub EventLoop(ByVal Cli As TcpClient, ByVal Reader As StreamReader, ByVal Writer As StreamWriter)
        Try
            Dim Z As Zival, Cmd As String, CmdA() As String, Delimiter() As Char = New Char() {" "}
            While True
                Cmd = Reader.ReadLine()
                CmdA = Cmd.Split(Delimiter)
                If CmdA(0) = "ADIJO" Then Return
                If CmdA(0).StartsWith("KONEC_IGRE") Then GoTo Continue
                If CmdA(0) <> "ZBUDI_SE" Then Throw New Exception("Napaka pri komunikaciji s streznikom.")
                Dim J0 As Koordinate = New Koordinate(Double.Parse(CmdA(1), IC), Double.Parse(CmdA(2), IC))
                Dim N0 As Koordinate = New Koordinate(Double.Parse(CmdA(3), IC), Double.Parse(CmdA(4), IC))
                Dim ZeljenaSmer As Double
                Z = New Zival
                Z.ZbudiSe(J0, N0, ZeljenaSmer)
                Writer.WriteLine("BUDNA " + ZeljenaSmer.ToString())
                While True
                    Cmd = Reader.ReadLine()
                    CmdA = Cmd.Split(Delimiter)
                    If CmdA(0) = "ADIJO" Then Return
                    If CmdA(0) = "KONEC_IGRE" Then
                        Dim Razlog As Integer = Int32.Parse(CmdA(1))
                        Z.KonecIgre(CType(Razlog, Zival.Razlog))
                        Z = Nothing
                        Exit While
                    ElseIf CmdA(0) = "QV" Then
                        Dim J As Stanje = Parse(CmdA(1), CmdA(2), CmdA(3), CmdA(4))
                        Dim N As Stanje = Parse(CmdA(5), CmdA(6), CmdA(7), CmdA(8))
                        Dim SpremembaHitrosti As Double = 0.0, SpremembaSmeri As Double = 0.0
                        Z.KamGres(J, N, SpremembaSmeri, SpremembaHitrosti)
                        Writer.WriteLine("QVR " & SpremembaSmeri.ToString() & " " & SpremembaHitrosti.ToString())
                        Console.WriteLine(String.Format(IC, "d={0:F5} dD={1:F5} v={2:F5} dV={3:F}", J.Smer.D, SpremembaSmeri, J.Smer.V, SpremembaHitrosti))
                    Else
                    End If
                End While
Continue:
            End While
        Catch ex As Exception
            Console.WriteLine("Napaka: " & ex.ToString())
        End Try
    End Sub

    Shared Function Connect(ByVal HostName As String, ByRef Reader As StreamReader, ByRef Writer As StreamWriter) As TcpClient
        Dim Client As TcpClient = New TcpClient(HostName, 1174)
        Reader = New StreamReader(Client.GetStream())
        Writer = New StreamWriter(Client.GetStream())
        Writer.AutoFlush = True

        Dim Server As String = Reader.ReadLine()
        Console.WriteLine(Server)

        Dim Tip As String : If Zival.Tip = Zival.Pasma.Muca Then Tip = "MACKA" Else Tip = "MIS"
        Writer.WriteLine("AVE " & Tip & " " & Zival.Ime)
        Dim Succ As String = Reader.ReadLine()
        If Succ <> "PRIJAVA USPESNA" Then Throw New Exception("Prijava na streznik neuspesna: " & Succ)
        Return Client
    End Function

    Shared Sub Main(ByVal Args() As String)
        Dim HostName As String
        If Args.Length < 2 Then HostName = "localhost" _
        Else HostName = Args(1)

        Dim Reader As StreamReader, Writer As StreamWriter
        Dim Client As TcpClient = Connect(HostName, Reader, Writer)
        EventLoop(Client, Reader, Writer)
    End Sub

End Class

' Pozicija zivali.
Public Class Koordinate
    Public X As Double, Y As Double
    Public Sub New(ByVal X_ As Double, ByVal Y_ As Double)
        X = X_
        Y = Y_
    End Sub
End Class

' Smer gibanja; d = kot v radianih, v = hitrost v 1.0/korak
Public Class Smer
    Public D As Double, V As Double
    Public Sub New(ByVal D_ As Double, ByVal V_ As Double)
        D = D_
        V = V_
    End Sub
End Class

' Pozicija in smer zivali.
Public Class Stanje
    Public Koordinate As Koordinate
    Public Smer As Smer
    Public Sub New(ByVal X As Double, ByVal Y As Double, ByVal D As Double, ByVal V As Double)
        Koordinate = New Koordinate(X, Y)
        Smer = New Smer(D, V)
    End Sub
End Class
